# Class ConstantClass

java.lang.Object
org.apache.bcel.classfile.Constant
org.apache.bcel.classfile.ConstantClass

All Implemented Interfaces:
  `Cloneable, ConstantObject, Node`

public final class ConstantClass extends Constant implements ConstantObject
This class is derived from the abstract `Constant` and represents a reference to a (external) class.

See Also:
  - `Constant`

- ## Field Summary

  ### Fields inherited from class Constant

  `tag`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ConstantClass(int nameIndex)`
  Constructs a ConstantClass.
  `ConstantClass(ConstantClass c)`
  Initialize from another object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `accept(Visitor v)`
  Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class.
  `void`
  `dump(DataOutputStream file)`
  Dumps constant class to file stream in binary format.
  `String`
  `getBytes(ConstantPool cp)`
  Gets the dereferenced string.
  `Object`
  `getConstantValue(ConstantPool cp)`
  Gets the String object.
  `int`
  `getNameIndex()`
  Gets the name index in constant pool of class name.
  `void`
  `setNameIndex(int nameIndex)`
  Sets the name index in the constant pool.
  `String`
  `toString()`

  ### Methods inherited from class Constant

  `clone, copy, equals, getComparator, getTag, hashCode, readConstant, setComparator`

  ### Methods inherited from class Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### ConstantClass

    public ConstantClass(ConstantClass c)
    Initialize from another object.
    Parameters:
      `c` - Source to copy.

  - ### ConstantClass

    public ConstantClass(int nameIndex)
    Constructs a ConstantClass.
    Parameters:
      `nameIndex` - Name index in constant pool. Should refer to a ConstantUtf8.

- ## Method Details

  - ### accept

    public void accept(Visitor v)
    Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class. I.e., the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.
    Specified by:
      `accept` in interface `Node`
    Specified by:
      `accept` in class `Constant`
    Parameters:
      `v` - Visitor object.

  - ### dump

    public void dump(DataOutputStream file) throws IOException
    Dumps constant class to file stream in binary format.
    Specified by:
      `dump` in class `Constant`
    Parameters:
      `file` - Output file stream.
    Throws:
      `IOException` - if an I/O error occurs writing to the DataOutputStream.

  - ### getBytes

    public String getBytes(ConstantPool cp)
    Gets the dereferenced string.
    Parameters:
      `cp` - the constant pool.
    Returns:
      dereferenced string.

  - ### getConstantValue

    public Object getConstantValue(ConstantPool cp)
    Gets the String object.
    Specified by:
      `getConstantValue` in interface `ConstantObject`
    Parameters:
      `cp` - the constant pool.
    Returns:
      String object.

  - ### getNameIndex

    public int getNameIndex()
    Gets the name index in constant pool of class name.
    Returns:
      Name index in constant pool of class name.

  - ### setNameIndex

    public void setNameIndex(int nameIndex)
    Sets the name index in the constant pool.
    Parameters:
      `nameIndex` - the name index in the constant pool of this Constant Class.

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Constant`
    Returns:
      String representation.